program execonly;
{ This program uses one of the Novell NetWare/MUSLS functions to
  flag a file "execute only" (as well as shareable, read only).}

{
  Copyright 1987, Syracuse University
  Program Author: Don Hanley
  Modified for Batch use, D. K. Boeshaar 1990
}



type
    LongString = String[255];
var
    FileID: String[12];
    ErrCode: Integer;

Function Lock(FileName: LongString): Integer;
type
    regpack = record
                  ax,bx,cx,dx,bp,di,si,ds,es,flags: integer;
              end;
    FCBdef = record
              Drive: byte;              {0: default, 1:A, 2:B, etc.}
              FileName: Array[1..8] of char;
              FileExt: Array[1..3] of char;
              CurBlockNo: Array[1..2] of byte;
              RecSize: Array[1..2] of byte;  {Logical record size in bytes}
              FileSize: Array[1..4] of byte; {LSB first, file size in bytes}
              Date: Array[1..2] of byte; {<          2         > <       1     >
                                           15 14 13 12 11 10 9 8 7 6 5 4 3 2 1 0
                                            y  y  y  y  y  y y m m m m d d d d d}
              Reserved: Array[1..10] of byte;
              CurRecNo: byte;            {0-127; rec no within block}
              RelRecNo: Array[1..4] of byte; {rec no rel to start of file}
            end;
    FIBpointerdef = ^FIBdef;
    FIBdef = record
              Flags: byte;
              FileType: byte;
              CharBuff: byte;
              SectorPntr: byte;
              NoRecsLSB: byte;
              Fill1: Array[1..2] of byte;
              NoRecsMSB: byte;
              Fill2: Array[1..3] of byte;
              FCB: FCBdef;   {37 bytes}
              SectorBuff: Array[1..128] of char;
           end;

var
   recpack: regpack;
   EXECFile: File;
   FIBpointer: FIBpointerdef;
   FIB: FIBdef absolute EXECFile;
   i: integer;
begin
     with recpack do
     begin
          ax:= $E400;  {set file attributes}
          Assign (EXECFile, Filename);
          FIBpointer:= addr(EXECFile);
          ds:= seg(FIBpointer^.FCB);
          dx:= ofs(FIBpointer^.FCB);
          cx:= $0089;    {shareable, execute only, read only}
          intr($21,recpack);
          Lock:= ax and $00FF;  {error code}
     end;
end;


begin

     FileID := paramstr(1);
     ErrCode:= Lock (FileID);
      If ErrCode <> 0 then
               begin
                   Writeln (chr(7),' *** Error ',ErrCode,' ***');
                   Writeln ('Error with file: ', FileID);
                   Writeln;
               end

       else Writeln('File: ', FileID, ' Set to Shareable, Execute Only');

end.
